<!---
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the Starter App directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2010.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files
in this directory, you agree to the terms and conditions of the applicable
end user license agreement.
--->

<cfscript>
	// the fields current value
	currentValue = attributes.currentValues[fqFieldName];
	// the param structure which will hold all of the fields from the props dialog
	xparams = parameters[fieldQuery.inputID];

	//--Field Security--
	readOnly = application.ADF.forms.isFieldReadOnly(xparams);
</cfscript>
<cfoutput>
   <link rel="stylesheet" href="/ADF/apps/customer_knowledge_map/style/customerKnowledgeMapStyles.css" type="text/css"/>
	<script>
		// javascript validation to make sure they have text to be converted
		#fqFieldName#=new Object();
		#fqFieldName#.id='#fqFieldName#';
		#fqFieldName#.tid=#rendertabindex#;
		#fqFieldName#.msg="Please select a value for the #xparams.label# field.";
		#fqFieldName#.validator = "validate_#fqFieldName#()";

		//If the field is required
		if ( '#xparams.req#' == 'Yes' ){
			// push on to validation array
			vobjects_#attributes.formname#.push(#fqFieldName#);
		}

		//Validation function
		function validate_#fqFieldName#(){
			if (jQuery("input[name=#fqFieldName#]").val() != ''){
				return true;
			}else{
				return false;
			}
		}

		jQuery(document).ready(function(){
			handleAnswerChange();
			jQuery(".#fqFieldName#_accordion").accordion({
				autoHeight: false,
				change: function(){
					ResizeWindow();
				}
			});
			jQuery(".#fqFieldName#_accordion input").change(handleAnswerChange);
		});

		function handleAnswerChange(){
			var valueToSet = "";
			jQuery(".#fqFieldName#_accordion input:checked").each(function(){
				valueToSet += jQuery(this).val()+",";
			});
			jQuery("###fqFieldName#").val(valueToSet);
		}
	</script>
	<cfscript>
		selectedQuestion = "";
		if(StructKeyExists(request.params,"selectedQuestion")){
			selectedQuestion = request.params.selectedQuestion;
		}
		json = server.ADF.objectFactory.getBean("json");
		qaMapping = StructNew();
		if(StructKeyExists(request.params,"questionAnswerMapping")){
			qaMapping = json.decode(request.params.questionAnswerMapping);
		}
		questions = application.customerKnowledgeMap.DAO.getQuestion();
		questions = application.customerKnowledgeMap.ceData.arrayOfCEDataSort(questions,"groupName");
		
		//Set the header to the first one by default
		header = "";
	</cfscript>
	<cfif !StructIsEmpty(qaMapping)>
		<cfsavecontent variable="inputHTML">
			<div id="ckmContainer" class="#fqFieldName#_accordion" >
				<cfloop array="#questions#" index="question">
					<!---	Only show questions which we have answers for--->
					<cfif StructKeyExists(qaMapping,question.values.id)>
						<!---	Grab the answerID from the question answer mapping struct--->
						<cfset answerID = StructFind(qaMapping,question.values.id)>

						<!--- If the header is not the existing header add the new one and start a new div --->
						<cfif header neq question.values.groupName>
							<cfif header neq "">
									</table>
								</div>
							</cfif>
							<cfset header = question.values.groupName>
							 <h3 id="#question.values.groupID#"><a href="##">#header#</a></h3>
							 <div>
								<table class="questionAnswerSelection">
									<tbody valign="top">
						</cfif>

						<!---	If it is one of the selected questions select the group--->
						<cfif ListFind(selectedQuestion,answerID)>
							<script type="text/javascript">
								jQuery(document).ready(function(){
									jQuery("###fqFieldName#_accordion").accordion("activate" , "###question.values.groupID#");
								});
							</script>
						</cfif>
						<tr>
							<td>
								<!---	Add the checkbox--->
								<input type="checkbox"
										name="#fqFieldName#_answers"
										id="#fqFieldName#_#answerID#"
										value="#answerID#"
										<cfif ListFind(selectedQuestion,answerID)>checked="true"</cfif>
								/>
							</td>
							<td class="questionLabel">
								<label for="#fqFieldName#_#answerID#" class="priority#question.values.priority#">#question.values.label#</label>
							</td>
							<td class="answerString">
								<!---	Get the answer, then display it to the screen--->
								<cfscript>
									answer = application.customerKnowledgeMap.DAO.getAnswer(answerID=answerID);
								</cfscript>
								#answer[1].answer#
							</td>
						</tr>
					</cfif>
				</cfloop>
				<!---	Finalize the last table and div--->
				</table>
				</div>
			</div>
			<cfoutput>
				<input name="#fqFieldName#" id='#fqFieldName#' value="#currentValue#" type="hidden">
			</cfoutput>
		</cfsavecontent>
		#application.ADF.forms.wrapFieldHTML(inputHTML,fieldQuery,attributes,false)#
	<cfelse>
		<tr>
			<td>This story will not be related to any questions.</td>
		</tr>
	</cfif>
</cfoutput>